set more off
set rmsg on
capture cd "C:\Users\zp53\Dropbox\rdd6"
log using "logs\sim_emp_kink3_quintic_ll", replace

parallel setclusters 4

capture program drop sim_clpw_kink3_quintic_newdata
program define sim_clpw_kink3_quintic_newdata, rclass

syntax [, obs(integer 275292) poly(integer 1)]

use "data\pooling_andrea_k3and4_2014.dta", clear

gen v = basis_centered

gen logtagsatzleist = log(tagsatzleist)

rename ltimenext Y
rename logtagsatzleist B

keep if kink3 == 1

keep Y B v

gen d = (v>=0)

gen dv = d*v

gen v2 = v^2

gen dv2 = d*v^2

gen v3 = v^3

gen dv3 = d*v^3

gen v4 = v^4

gen dv4 = d*v^4

gen v5 = v^5

gen dv5 = d*v^5

scalar coeff_Y_dv = 0.0000299
scalar coeff_B_dv = 0.000023

gen Ypartial = Y - coeff_Y_dv * dv
gen Bpartial = B - coeff_B_dv * dv

** kink **

reg Ypartial v v2 dv2 v3 dv3 v4 dv4 v5 dv5
predict epsilon_hat, res

scalar coeff_Y_cons = _b[_cons] 
scalar coeff_Y_v =  _b[v]
scalar coeff_Y_v2 = _b[v2]
scalar coeff_Y_dv2 = _b[dv2] 
scalar coeff_Y_v3 = _b[v3] 
scalar coeff_Y_dv3 = _b[dv3] 
scalar coeff_Y_v4 = _b[v4]
scalar coeff_Y_dv4 = _b[dv4]
scalar coeff_Y_v5 = _b[v5]
scalar coeff_Y_dv5 = _b[dv5]
scalar Y_rmse = e(rmse)


reg Bpartial v v2 dv2 v3 dv3 v4 dv4 v5 dv5
predict u_hat, res

scalar coeff_B_cons = _b[_cons] 
scalar coeff_B_v =  _b[v] 
scalar coeff_B_v2 = _b[v2]
scalar coeff_B_dv2 =  _b[dv2]   
scalar coeff_B_v3 = _b[v3]  
scalar coeff_B_dv3 = _b[dv3]
scalar coeff_B_v4 = _b[v4]
scalar coeff_B_dv4 = _b[dv4]
scalar coeff_B_v5 = _b[v5]
scalar coeff_B_dv5 = _b[dv5]
scalar B_rmse = e(rmse) 

scalar truekink = coeff_Y_dv/coeff_B_dv
scalar truefs  = coeff_B_dv

rename epsilon_hat epsilon
rename u_hat u

keep v u epsilon

*save "data\forsim_kink3_quintic.dta", replace


*use "data\forsim_kink3_quintic.dta", clear

preserve 

keep v

bsample `obs'

gen id = _n

tempfile v_only
save "`v_only'"

restore

keep epsilon u

bsample `obs'

gen id = _n

merge 1:1 id using "`v_only'"

drop _merge id

gen d = (v>=0)

gen Y = coeff_Y_cons + coeff_Y_v * v + coeff_Y_dv * d * v + ///
coeff_Y_v2 * v^2 + coeff_Y_dv2 * d *v^2 + coeff_Y_v3 * v^3 + ///
coeff_Y_dv3 * d * v^3 + coeff_Y_v4 * v^4 + coeff_Y_dv4 * d * v^4 + ///
coeff_Y_v5 * v^5 + coeff_Y_dv5 * d * v^5 + epsilon

gen B = coeff_B_cons + coeff_B_v * v + coeff_B_dv * d * v + ///
coeff_B_v2 * v^2 + coeff_B_dv2 * d *v^2 + coeff_B_v3 * v^3 + ///
coeff_B_dv3 * d * v^3 + coeff_B_v4 * v^4 + coeff_B_dv4 * d * v^4 + ///
coeff_B_v5 * v^5 + coeff_B_dv5 * d * v^5 + u

local poly_p1=`poly'+1

capture rdrobust Y v, fuzzy(B [sharpbw]) deriv(1) p(`poly') q(`poly_p1') kernel(uniform) bwselect(mserd)

scalar ci_upper_rb_CCT=`e(ci_r_rb)'
scalar ci_lower_rb_CCT=`e(ci_l_rb)'
scalar h_bw_CCT = e(h_l)
scalar b_bw_CCT = e(b_l)
scalar cover_rb_CCT = ((ci_upper_rb_CCT>=truekink) & (ci_lower_rb_CCT<=truekink))
scalar tau_F_bc_CCT = e(tau_bc)
scalar ci_upper_T_rb_CCT = e(ci_T_r_rb)
scalar ci_lower_T_rb_CCT = e(ci_T_l_rb)
scalar t_T_rb_CCT = e(t_T_rb)
scalar pv_T_rb_CCT = e(pv_T_rb)
scalar tau_T_bc_CCT = e(tau_T_bc)
scalar cover_T_rb_CCT = ((ci_upper_T_rb_CCT>=truefs) & (ci_lower_T_rb_CCT<=truefs))

capture rdrobust Y v, fuzzy(B [sharpbw]) deriv(1) p(`poly') q(`poly_p1') kernel(uniform) bwselect(mserd) scaleregul(0)

scalar ci_upper_rb_CCTnoreg=`e(ci_r_rb)'
scalar ci_lower_rb_CCTnoreg=`e(ci_l_rb)'
scalar h_bw_CCTnoreg = e(h_l)
scalar b_bw_CCTnoreg = e(b_l)
scalar cover_rb_CCTnoreg = ((ci_upper_rb_CCTnoreg>=truekink) & (ci_lower_rb_CCTnoreg<=truekink))
scalar tau_F_bc_CCTnoreg = e(tau_bc)
scalar ci_upper_T_rb_CCTnoreg = e(ci_T_r_rb)
scalar ci_lower_T_rb_CCTnoreg = e(ci_T_l_rb)
scalar t_T_rb_CCTnoreg = e(t_T_rb)
scalar pv_T_rb_CCTnoreg = e(pv_T_rb)
scalar tau_T_bc_CCTnoreg = e(tau_T_bc)
scalar cover_T_rb_CCTnoreg = ((ci_upper_T_rb_CCTnoreg>=truefs) & (ci_lower_T_rb_CCTnoreg<=truefs))

capture rdrobust Y v, fuzzy(B) deriv(1) p(`poly') q(`poly_p1') kernel(uniform) bwselect(mserd) scaleregul(0)

scalar ci_upper_rb_fuzzyCCT=`e(ci_r_rb)'
scalar ci_lower_rb_fuzzyCCT=`e(ci_l_rb)'
scalar h_bw_fuzzyCCT = e(h_l)
scalar b_bw_fuzzyCCT = e(b_l)
scalar cover_rb_fuzzyCCT = ((ci_upper_rb_fuzzyCCT>=truekink) & (ci_lower_rb_fuzzyCCT<=truekink))
scalar tau_F_bc_fuzzyCCT = e(tau_bc)
scalar ci_upper_T_rb_fuzzyCCT = e(ci_T_r_rb)
scalar ci_lower_T_rb_fuzzyCCT = e(ci_T_l_rb)
scalar t_T_rb_fuzzyCCT = e(t_T_rb)
scalar pv_T_rb_fuzzyCCT = e(pv_T_rb)
scalar tau_T_bc_fuzzyCCT = e(tau_T_bc)
scalar cover_T_rb_fuzzyCCT = ((ci_upper_T_rb_fuzzyCCT>=truefs) & (ci_lower_T_rb_fuzzyCCT<=truefs))


capture rdrobust Y v, fuzzy(B) deriv(1) p(`poly') q(`poly_p1') kernel(uniform) bwselect(msetwo) scaleregul(0)

scalar ci_upper_rb_fuzzyTWO=`e(ci_r_rb)'
scalar ci_lower_rb_fuzzyTWO=`e(ci_l_rb)'
scalar h_l_fuzzyTWO = e(h_l)
scalar h_r_fuzzyTWO = e(h_r)
scalar b_l_fuzzyTWO = e(b_l)
scalar b_r_fuzzyTWO = e(b_r)
scalar cover_rb_fuzzyTWO = ((ci_upper_rb_fuzzyTWO>=truekink) & (ci_lower_rb_fuzzyTWO<=truekink))
scalar tau_F_bc_fuzzyTWO = e(tau_bc)
scalar ci_upper_T_rb_fuzzyTWO = e(ci_T_r_rb)
scalar ci_lower_T_rb_fuzzyTWO = e(ci_T_l_rb)
scalar t_T_rb_fuzzyTWO = e(t_T_rb)
scalar pv_T_rb_fuzzyTWO = e(pv_T_rb)
scalar tau_T_bc_fuzzyTWO = e(tau_T_bc)
scalar cover_T_rb_fuzzyTWO = ((ci_upper_T_rb_fuzzyTWO>=truefs) & (ci_lower_T_rb_fuzzyTWO<=truefs))

capture rdrobust Y v, fuzzy(B) deriv(1) p(`poly') q(`poly_p1') kernel(uniform) bwselect(cerrd) scaleregul(0)

scalar ci_upper_rb_fuzzyCERCCT=`e(ci_r_rb)'
scalar ci_lower_rb_fuzzyCERCCT=`e(ci_l_rb)'
scalar h_bw_fuzzyCERCCT = e(h_l)
scalar b_bw_fuzzyCERCCT = e(b_l)
scalar cover_rb_fuzzyCERCCT = ((ci_upper_rb_fuzzyCERCCT>=truekink) & (ci_lower_rb_fuzzyCERCCT<=truekink))
scalar tau_F_bc_fuzzyCERCCT = e(tau_bc)
scalar ci_upper_T_rb_fuzzyCERCCT = e(ci_T_r_rb)
scalar ci_lower_T_rb_fuzzyCERCCT = e(ci_T_l_rb)
scalar t_T_rb_fuzzyCERCCT = e(t_T_rb)
scalar pv_T_rb_fuzzyCERCCT = e(pv_T_rb)
scalar tau_T_bc_fuzzyCERCCT = e(tau_T_bc)
scalar cover_T_rb_fuzzyCERCCT = ((ci_upper_T_rb_fuzzyCERCCT>=truefs) & (ci_lower_T_rb_fuzzyCERCCT<=truefs))


capture rdrobust Y v, fuzzy(B) deriv(1) p(`poly') q(`poly_p1') kernel(uniform) bwselect(certwo) scaleregul(0)

scalar ci_upper_rb_fuzzyCERTWO=`e(ci_r_rb)'
scalar ci_lower_rb_fuzzyCERTWO=`e(ci_l_rb)'
scalar h_l_fuzzyCERTWO = e(h_l)
scalar h_r_fuzzyCERTWO = e(h_r)
scalar b_l_fuzzyCERTWO = e(b_l)
scalar b_r_fuzzyCERTWO = e(b_r)
scalar cover_rb_fuzzyCERTWO = ((ci_upper_rb_fuzzyCERTWO>=truekink) & (ci_lower_rb_fuzzyCERTWO<=truekink))
scalar tau_F_bc_fuzzyCERTWO = e(tau_bc)
scalar ci_upper_T_rb_fuzzyCERTWO = e(ci_T_r_rb)
scalar ci_lower_T_rb_fuzzyCERTWO = e(ci_T_l_rb)
scalar t_T_rb_fuzzyCERTWO = e(t_T_rb)
scalar pv_T_rb_fuzzyCERTWO = e(pv_T_rb)
scalar tau_T_bc_fuzzyCERTWO = e(tau_T_bc)
scalar cover_T_rb_fuzzyCERTWO = ((ci_upper_T_rb_fuzzyCERTWO>=truefs) & (ci_lower_T_rb_fuzzyCERTWO<=truefs))

gen dv = d*v
gen v2 = v^2
gen dv2 = d*v^2
gen v3 = v^3
gen v4 = v^4

qui sum v
local Sx = r(sd)
local h1 = 1.84 * `Sx' * (_N)^(-1/5)
count if abs(v)<`h1'
scalar f0 = r(N)/(2 * _N * `h1')


if (`poly'==1) {

	reg Y dv v v2, robust
	scalar sigmasq = e(rmse)^2
	scalar m2sq = (2*(_b[v2]))^2
	scalar h_bw_FG = 2.352158 * (( sigmasq/(m2sq * f0) )^(1/5)) * (e(N)^(-(1/5)))
	local h_bw_FG = h_bw_FG
	
	
	reg Y dv v v2 v3, robust
	scalar sigmasq = e(rmse)^2
	scalar m3sq = (6*(_b[v3]))^2
	scalar b_bw_FG = 3.556702167*((sigmasq/(m3sq * f0))^(1/7)) * (e(N)^(-(1/7)))
	local b_bw_FG = b_bw_FG 

				}
				
if (`poly'==2) {				

	qui reg Y dv v v2 v3, robust
	scalar sigmasq = e(rmse)^2
	scalar m3sq = (6*(_b[v3]))^2
	scalar h_bw_FG = 3.9269176 * (( sigmasq/(m3sq * f0) )^(1/7)) * (e(N)^(-(1/7)))
	local h_bw_FG = h_bw_FG
	
	qui reg Y dv v v2 v3 v4, robust
	scalar sigmasq = e(rmse)^2
	scalar m4sq = (24*(_b[v4]))^2
	scalar b_bw_FG = 5.208775878*((sigmasq/(m4sq * f0))^(1/9)) * (e(N)^(-(1/9)))
	local b_bw_FG = b_bw_FG
	
				}

capture rdrobust Y v, fuzzy(B) deriv(1) p(`poly') q(`poly_p1') h(`h_bw_FG') b(`b_bw_FG') kernel(uniform)
scalar ci_upper_rb_FG=`e(ci_r_rb)'
scalar ci_lower_rb_FG=`e(ci_l_rb)'
scalar h_bw_FG = e(h_l)
scalar b_bw_FG = e(b_l)
scalar cover_rb_FG = ((ci_upper_rb_FG>=truekink) & (ci_lower_rb_FG<=truekink))
scalar tau_F_bc_FG = e(tau_bc)
scalar ci_upper_T_rb_FG = e(ci_T_r_rb)
scalar ci_lower_T_rb_FG = e(ci_T_l_rb)
scalar t_T_rb_FG = e(t_T_rb)
scalar pv_T_rb_FG = e(pv_T_rb)
scalar tau_T_bc_FG = e(tau_T_bc)
scalar cover_T_rb_FG = ((ci_upper_T_rb_FG>=truefs) & (ci_lower_T_rb_FG<=truefs))

capture rdrobust Y v, fuzzy(B) deriv(1) p(`poly') q(`poly_p1') h(20000) kernel(uniform)
scalar ci_upper_rb_max=`e(ci_r_rb)'
scalar ci_lower_rb_max=`e(ci_l_rb)'
scalar h_bw_max = e(h_l)
scalar b_bw_max = e(b_l)
scalar cover_rb_max = ((ci_upper_rb_max>=truekink) & (ci_lower_rb_max<=truekink))
scalar tau_F_bc_max = e(tau_bc)
scalar ci_upper_T_rb_max = e(ci_T_r_rb)
scalar ci_lower_T_rb_max = e(ci_T_l_rb)
scalar t_T_rb_max = e(t_T_rb)
scalar pv_T_rb_max = e(pv_T_rb)
scalar tau_T_bc_max = e(tau_T_bc)
scalar cover_T_rb_max = ((ci_upper_T_rb_max>=truefs) & (ci_lower_T_rb_max<=truefs))				

if (`poly'==1) {


	quietly reg Y v B (v dv) if (v<h_bw_CCT & v>-h_bw_CCT), robust	
	scalar tau_F_cl_CCT = _b[B]
	scalar se_F_cl_CCT = _se[B]	
	scalar ci_upper_cl_CCT = _b[B] + 1.959964 * se_F_cl_CCT
	scalar ci_lower_cl_CCT = _b[B] - 1.959964 * se_F_cl_CCT
	scalar cover_cl_CCT = ((ci_upper_cl_CCT>=truekink) & (ci_lower_cl_CCT<=truekink))

	quietly reg B v dv if (v<h_bw_CCT & v>-h_bw_CCT), robust	
	scalar tau_T_cl_CCT = _b[dv]
	scalar se_T_cl_CCT = _se[dv]
	scalar Fstat_T_cl_CCT = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_CCT = _b[dv] + 1.959964 * se_T_cl_CCT
	scalar ci_lower_T_cl_CCT = _b[dv] - 1.959964 * se_T_cl_CCT
	scalar cover_T_cl_CCT = ((ci_upper_T_cl_CCT>=truefs) & (ci_lower_T_cl_CCT<=truefs))	

	quietly reg Y v B (v dv) if (v<h_bw_CCTnoreg & v>-h_bw_CCTnoreg), robust	
	scalar tau_F_cl_CCTnoreg = _b[B]
	scalar se_F_cl_CCTnoreg = _se[B]		
	scalar ci_upper_cl_CCTnoreg = _b[B] + 1.959964 * se_F_cl_CCTnoreg
	scalar ci_lower_cl_CCTnoreg = _b[B] - 1.959964 * se_F_cl_CCTnoreg
	scalar cover_cl_CCTnoreg = ((ci_upper_cl_CCTnoreg>=truekink) & (ci_lower_cl_CCTnoreg<=truekink))	

	quietly reg B v dv if (v<h_bw_CCTnoreg & v>-h_bw_CCTnoreg), robust	
	scalar tau_T_cl_CCTnoreg = _b[dv]
	scalar se_T_cl_CCTnoreg = _se[dv]	
	scalar Fstat_T_cl_CCTnoreg = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_CCTnoreg = _b[dv] + 1.959964 * se_T_cl_CCTnoreg
	scalar ci_lower_T_cl_CCTnoreg = _b[dv] - 1.959964 * se_T_cl_CCTnoreg
	scalar cover_T_cl_CCTnoreg = ((ci_upper_T_cl_CCTnoreg>=truefs) & (ci_lower_T_cl_CCTnoreg<=truefs))		
	
	quietly reg Y v B (v dv) if (v<h_bw_fuzzyCCT & v>-h_bw_fuzzyCCT), robust	
	scalar tau_F_cl_fuzzyCCT = _b[B]
	scalar se_F_cl_fuzzyCCT = _se[B]
	scalar ci_upper_cl_fuzzyCCT = _b[B] + 1.959964 * se_F_cl_fuzzyCCT
	scalar ci_lower_cl_fuzzyCCT = _b[B] - 1.959964 * se_F_cl_fuzzyCCT
	scalar cover_cl_fuzzyCCT = ((ci_upper_cl_fuzzyCCT>=truekink) & (ci_lower_cl_fuzzyCCT<=truekink))	

	quietly reg B v dv if (v<h_bw_fuzzyCCT & v>-h_bw_fuzzyCCT), robust	
	scalar tau_T_cl_fuzzyCCT = _b[dv]
	scalar se_T_cl_fuzzyCCT = _se[dv]	
	scalar Fstat_T_cl_fuzzyCCT = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_fuzzyCCT = _b[dv] + 1.959964 * se_T_cl_fuzzyCCT
	scalar ci_lower_T_cl_fuzzyCCT = _b[dv] - 1.959964 * se_T_cl_fuzzyCCT
	scalar cover_T_cl_fuzzyCCT = ((ci_upper_T_cl_fuzzyCCT>=truefs) & (ci_lower_T_cl_fuzzyCCT<=truefs))		
	
	quietly reg Y v B (v dv) if (v<h_r_fuzzyTWO & v>-h_l_fuzzyTWO), robust
	scalar tau_F_cl_fuzzyTWO = _b[B]
	scalar se_F_cl_fuzzyTWO = _se[B]
	scalar ci_upper_cl_fuzzyTWO = _b[B] + 1.959964 * se_F_cl_fuzzyTWO
	scalar ci_lower_cl_fuzzyTWO = _b[B] - 1.959964 * se_F_cl_fuzzyTWO
	scalar cover_cl_fuzzyTWO = ((ci_upper_cl_fuzzyTWO>=truekink) & (ci_lower_cl_fuzzyTWO<=truekink))
	
	quietly reg B v dv if (v<h_r_fuzzyTWO & v>-h_l_fuzzyTWO), robust	
	scalar tau_T_cl_fuzzyTWO = _b[dv]
	scalar se_T_cl_fuzzyTWO = _se[dv]
	scalar Fstat_T_cl_fuzzyTWO = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_fuzzyTWO = _b[dv] + 1.959964 * se_T_cl_fuzzyTWO
	scalar ci_lower_T_cl_fuzzyTWO = _b[dv] - 1.959964 * se_T_cl_fuzzyTWO
	scalar cover_T_cl_fuzzyTWO = ((ci_upper_T_cl_fuzzyTWO>=truefs) & (ci_lower_T_cl_fuzzyTWO<=truefs))			

	quietly reg Y v B (v dv) if (v<h_bw_fuzzyCERCCT & v>-h_bw_fuzzyCERCCT), robust	
	scalar tau_F_cl_fuzzyCERCCT = _b[B]
	scalar se_F_cl_fuzzyCERCCT = _se[B]
	scalar ci_upper_cl_fuzzyCERCCT = _b[B] + 1.959964 * se_F_cl_fuzzyCERCCT
	scalar ci_lower_cl_fuzzyCERCCT = _b[B] - 1.959964 * se_F_cl_fuzzyCERCCT
	scalar cover_cl_fuzzyCERCCT = ((ci_upper_cl_fuzzyCERCCT>=truekink) & (ci_lower_cl_fuzzyCERCCT<=truekink))	

	quietly reg B v dv if (v<h_bw_fuzzyCERCCT & v>-h_bw_fuzzyCERCCT), robust	
	scalar tau_T_cl_fuzzyCERCCT = _b[dv]
	scalar se_T_cl_fuzzyCERCCT = _se[dv]	
	scalar Fstat_T_cl_fuzzyCERCCT = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_fuzzyCERCCT = _b[dv] + 1.959964 * se_T_cl_fuzzyCERCCT
	scalar ci_lower_T_cl_fuzzyCERCCT = _b[dv] - 1.959964 * se_T_cl_fuzzyCERCCT
	scalar cover_T_cl_fuzzyCERCCT = ((ci_upper_T_cl_fuzzyCERCCT>=truefs) & (ci_lower_T_cl_fuzzyCERCCT<=truefs))		
	
	quietly reg Y v B (v dv) if (v<h_r_fuzzyCERTWO & v>-h_l_fuzzyCERTWO), robust
	scalar tau_F_cl_fuzzyCERTWO = _b[B]
	scalar se_F_cl_fuzzyCERTWO = _se[B]
	scalar ci_upper_cl_fuzzyCERTWO = _b[B] + 1.959964 * se_F_cl_fuzzyCERTWO
	scalar ci_lower_cl_fuzzyCERTWO = _b[B] - 1.959964 * se_F_cl_fuzzyCERTWO
	scalar cover_cl_fuzzyCERTWO = ((ci_upper_cl_fuzzyCERTWO>=truekink) & (ci_lower_cl_fuzzyCERTWO<=truekink))
	
	quietly reg B v dv if (v<h_r_fuzzyCERTWO & v>-h_l_fuzzyCERTWO), robust	
	scalar tau_T_cl_fuzzyCERTWO = _b[dv]
	scalar se_T_cl_fuzzyCERTWO = _se[dv]
	scalar Fstat_T_cl_fuzzyCERTWO = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_fuzzyCERTWO = _b[dv] + 1.959964 * se_T_cl_fuzzyCERTWO
	scalar ci_lower_T_cl_fuzzyCERTWO = _b[dv] - 1.959964 * se_T_cl_fuzzyCERTWO
	scalar cover_T_cl_fuzzyCERTWO = ((ci_upper_T_cl_fuzzyCERTWO>=truefs) & (ci_lower_T_cl_fuzzyCERTWO<=truefs))			

	quietly reg Y v B (v dv) if (v<h_bw_FG & v>-h_bw_FG), robust	
	scalar tau_F_cl_FG = _b[B]
	scalar se_F_cl_FG = _se[B]	
	scalar ci_upper_cl_FG = _b[B] + 1.959964 * se_F_cl_FG
	scalar ci_lower_cl_FG = _b[B] - 1.959964 * se_F_cl_FG
	scalar cover_cl_FG = ((ci_upper_cl_FG>=truekink) & (ci_lower_cl_FG<=truekink))
	
	quietly reg B v dv if (v<h_bw_FG & v>-h_bw_FG), robust	
	scalar tau_T_cl_FG = _b[dv]
	scalar se_T_cl_FG = _se[dv]	
	scalar Fstat_T_cl_FG = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_FG = _b[dv] + 1.959964 * se_T_cl_FG
	scalar ci_lower_T_cl_FG = _b[dv] - 1.959964 * se_T_cl_FG
	scalar cover_T_cl_FG = ((ci_upper_T_cl_FG>=truefs) & (ci_lower_T_cl_FG<=truefs))
	
	quietly reg Y v B (v dv) if (v<h_bw_max & v>-h_bw_max), robust	
	scalar tau_F_cl_max = _b[B]
	scalar se_F_cl_max = _se[B]		
	scalar ci_upper_cl_max = _b[B] + 1.959964 * se_F_cl_max
	scalar ci_lower_cl_max = _b[B] - 1.959964 * se_F_cl_max
	scalar cover_cl_max = ((ci_upper_cl_max>=truekink) & (ci_lower_cl_max<=truekink))
	
	quietly reg B v dv if (v<h_bw_max & v>-h_bw_max), robust	
	scalar tau_T_cl_max = _b[dv]
	scalar se_T_cl_max = _se[dv]		
	scalar Fstat_T_cl_max = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_max = _b[dv] + 1.959964 * se_T_cl_max
	scalar ci_lower_T_cl_max = _b[dv] - 1.959964 * se_T_cl_max
	scalar cover_T_cl_max = ((ci_upper_T_cl_max>=truefs) & (ci_lower_T_cl_max<=truefs))		
	
				}

if (`poly'==2) {


	quietly reg Y v v2 dv2 B (v v2 dv2 dv) if (v<h_bw_CCT & v>-h_bw_CCT), robust	
	scalar tau_F_cl_CCT = _b[B]
	scalar se_F_cl_CCT = _se[B]		
	scalar ci_upper_cl_CCT = _b[B] + 1.959964 * se_F_cl_CCT
	scalar ci_lower_cl_CCT = _b[B] - 1.959964 * se_F_cl_CCT
	scalar cover_cl_CCT = ((ci_upper_cl_CCT>=truekink) & (ci_lower_cl_CCT<=truekink))
	
	quietly reg B v v2 dv dv2 if (v<h_bw_CCT & v>-h_bw_CCT), robust
	scalar tau_T_cl_CCT = _b[dv]
	scalar se_T_cl_CCT = _se[dv]	
	scalar Fstat_T_cl_CCT = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_CCT = _b[dv] + 1.959964 * se_T_cl_CCT
	scalar ci_lower_T_cl_CCT = _b[dv] - 1.959964 * se_T_cl_CCT
	scalar cover_T_cl_CCT = ((ci_upper_T_cl_CCT>=truefs) & (ci_lower_T_cl_CCT<=truefs))	
	
	quietly reg Y v v2 dv2 B (v v2 dv2 dv) if (v<h_bw_CCTnoreg & v>-h_bw_CCTnoreg), robust	
	scalar tau_F_cl_CCTnoreg = _b[B]
	scalar se_F_cl_CCTnoreg = _se[B]
	scalar ci_upper_cl_CCTnoreg = _b[B] + 1.959964 * se_F_cl_CCTnoreg
	scalar ci_lower_cl_CCTnoreg = _b[B] - 1.959964 * se_F_cl_CCTnoreg
	scalar cover_cl_CCTnoreg = ((ci_upper_cl_CCTnoreg>=truekink) & (ci_lower_cl_CCTnoreg<=truekink))	

	quietly reg B v v2 dv dv2 if (v<h_bw_CCTnoreg & v>-h_bw_CCTnoreg), robust
	scalar tau_T_cl_CCTnoreg = _b[dv]
	scalar se_T_cl_CCTnoreg = _se[dv]	
	scalar Fstat_T_cl_CCTnoreg = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_CCTnoreg = _b[dv] + 1.959964 * se_T_cl_CCTnoreg
	scalar ci_lower_T_cl_CCTnoreg = _b[dv] - 1.959964 * se_T_cl_CCTnoreg
	scalar cover_T_cl_CCTnoreg = ((ci_upper_T_cl_CCTnoreg>=truefs) & (ci_lower_T_cl_CCTnoreg<=truefs))		
	
	quietly reg Y v v2 dv2 B (v v2 dv2 dv) if (v<h_bw_fuzzyCCT & v>-h_bw_fuzzyCCT), robust	
	scalar tau_F_cl_fuzzyCCT = _b[B]
	scalar se_F_cl_fuzzyCCT = _se[B]	
	scalar ci_upper_cl_fuzzyCCT = _b[B] + 1.959964 * se_F_cl_fuzzyCCT
	scalar ci_lower_cl_fuzzyCCT = _b[B] - 1.959964 * se_F_cl_fuzzyCCT
	scalar cover_cl_fuzzyCCT = ((ci_upper_cl_fuzzyCCT>=truekink) & (ci_lower_cl_fuzzyCCT<=truekink))	
	
	quietly reg B v v2 dv dv2 if (v<h_bw_fuzzyCCT & v>-h_bw_fuzzyCCT), robust
	scalar tau_T_cl_fuzzyCCT = _b[dv]
	scalar se_T_cl_fuzzyCCT = _se[dv]	
	scalar Fstat_T_cl_fuzzyCCT = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_fuzzyCCT = _b[dv] + 1.959964 * se_T_cl_fuzzyCCT
	scalar ci_lower_T_cl_fuzzyCCT = _b[dv] - 1.959964 * se_T_cl_fuzzyCCT
	scalar cover_T_cl_fuzzyCCT = ((ci_upper_T_cl_fuzzyCCT>=truefs) & (ci_lower_T_cl_fuzzyCCT<=truefs))			
	
	quietly reg Y v v2 dv2 B (v v2 dv2 dv) if (v<h_r_fuzzyTWO & v>-h_l_fuzzyTWO), robust
	scalar tau_F_cl_fuzzyTWO = _b[B]
	scalar se_F_cl_fuzzyTWO = _se[B]	
	scalar ci_upper_cl_fuzzyTWO = _b[B] + 1.959964 * se_F_cl_fuzzyTWO
	scalar ci_lower_cl_fuzzyTWO = _b[B] - 1.959964 * se_F_cl_fuzzyTWO
	scalar cover_cl_fuzzyTWO = ((ci_upper_cl_fuzzyTWO>=truekink) & (ci_lower_cl_fuzzyTWO<=truekink))
	
	quietly reg B v v2 dv dv2 if (v<h_r_fuzzyTWO & v>-h_l_fuzzyTWO), robust
	scalar tau_T_cl_fuzzyTWO = _b[dv]
	scalar se_T_cl_fuzzyTWO = _se[dv]	
	scalar Fstat_T_cl_fuzzyTWO = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_fuzzyTWO = _b[dv] + 1.959964 * se_T_cl_fuzzyTWO
	scalar ci_lower_T_cl_fuzzyTWO = _b[dv] - 1.959964 * se_T_cl_fuzzyTWO
	scalar cover_T_cl_fuzzyTWO = ((ci_upper_T_cl_fuzzyTWO>=truefs) & (ci_lower_T_cl_fuzzyTWO<=truefs))		

	quietly reg Y v v2 dv2 B (v v2 dv2 dv) if (v<h_bw_fuzzyCERCCT & v>-h_bw_fuzzyCERCCT), robust	
	scalar tau_F_cl_fuzzyCERCCT = _b[B]
	scalar se_F_cl_fuzzyCERCCT = _se[B]	
	scalar ci_upper_cl_fuzzyCERCCT = _b[B] + 1.959964 * se_F_cl_fuzzyCERCCT
	scalar ci_lower_cl_fuzzyCERCCT = _b[B] - 1.959964 * se_F_cl_fuzzyCERCCT
	scalar cover_cl_fuzzyCERCCT = ((ci_upper_cl_fuzzyCERCCT>=truekink) & (ci_lower_cl_fuzzyCERCCT<=truekink))	
	
	quietly reg B v v2 dv dv2 if (v<h_bw_fuzzyCERCCT & v>-h_bw_fuzzyCERCCT), robust
	scalar tau_T_cl_fuzzyCERCCT = _b[dv]
	scalar se_T_cl_fuzzyCERCCT = _se[dv]	
	scalar Fstat_T_cl_fuzzyCERCCT = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_fuzzyCERCCT = _b[dv] + 1.959964 * se_T_cl_fuzzyCERCCT
	scalar ci_lower_T_cl_fuzzyCERCCT = _b[dv] - 1.959964 * se_T_cl_fuzzyCERCCT
	scalar cover_T_cl_fuzzyCERCCT = ((ci_upper_T_cl_fuzzyCERCCT>=truefs) & (ci_lower_T_cl_fuzzyCERCCT<=truefs))			
	
	quietly reg Y v v2 dv2 B (v v2 dv2 dv) if (v<h_r_fuzzyCERTWO & v>-h_l_fuzzyCERTWO), robust
	scalar tau_F_cl_fuzzyCERTWO = _b[B]
	scalar se_F_cl_fuzzyCERTWO = _se[B]	
	scalar ci_upper_cl_fuzzyCERTWO = _b[B] + 1.959964 * se_F_cl_fuzzyCERTWO
	scalar ci_lower_cl_fuzzyCERTWO = _b[B] - 1.959964 * se_F_cl_fuzzyCERTWO
	scalar cover_cl_fuzzyCERTWO = ((ci_upper_cl_fuzzyCERTWO>=truekink) & (ci_lower_cl_fuzzyCERTWO<=truekink))
	
	quietly reg B v v2 dv dv2 if (v<h_r_fuzzyCERTWO & v>-h_l_fuzzyCERTWO), robust
	scalar tau_T_cl_fuzzyCERTWO = _b[dv]
	scalar se_T_cl_fuzzyCERTWO = _se[dv]	
	scalar Fstat_T_cl_fuzzyCERTWO = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_fuzzyCERTWO = _b[dv] + 1.959964 * se_T_cl_fuzzyCERTWO
	scalar ci_lower_T_cl_fuzzyCERTWO = _b[dv] - 1.959964 * se_T_cl_fuzzyCERTWO
	scalar cover_T_cl_fuzzyCERTWO = ((ci_upper_T_cl_fuzzyCERTWO>=truefs) & (ci_lower_T_cl_fuzzyCERTWO<=truefs))		

	quietly reg Y v v2 dv2 B (v v2 dv2 dv) if (v<h_bw_FG & v>-h_bw_FG), robust	
	scalar tau_F_cl_FG = _b[B]
	scalar se_F_cl_FG = _se[B]	
	scalar ci_upper_cl_FG = _b[B] + 1.959964 * se_F_cl_FG
	scalar ci_lower_cl_FG = _b[B] - 1.959964 * se_F_cl_FG
	scalar cover_cl_FG = ((ci_upper_cl_FG>=truekink) & (ci_lower_cl_FG<=truekink))
	
	quietly reg B v v2 dv dv2 if (v<h_bw_FG & v>-h_bw_FG), robust
	scalar tau_T_cl_FG = _b[dv]
	scalar se_T_cl_FG = _se[dv]		
	scalar Fstat_T_cl_FG = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_FG = _b[dv] + 1.959964 * se_T_cl_FG
	scalar ci_lower_T_cl_FG = _b[dv] - 1.959964 * se_T_cl_FG
	scalar cover_T_cl_FG = ((ci_upper_T_cl_FG>=truefs) & (ci_lower_T_cl_FG<=truefs))
	
	quietly reg Y v v2 dv2 B (v v2 dv2 dv) if (v<h_bw_max & v>-h_bw_max), robust	
	scalar tau_F_cl_max = _b[B]
	scalar se_F_cl_max = _se[B]	
	scalar ci_upper_cl_max = _b[B] + 1.959964 * se_F_cl_max
	scalar ci_lower_cl_max = _b[B] - 1.959964 * se_F_cl_max
	scalar cover_cl_max = ((ci_upper_cl_max>=truekink) & (ci_lower_cl_max<=truekink))
	
	quietly reg B v v2 dv dv2 if (v<h_bw_max & v>-h_bw_max), robust
	scalar tau_T_cl_max = _b[dv]
	scalar se_T_cl_max = _se[dv]		
	scalar Fstat_T_cl_max = (_b[dv]/_se[dv])^2
	scalar ci_upper_T_cl_max = _b[dv] + 1.959964 * se_T_cl_max
	scalar ci_lower_T_cl_max = _b[dv] - 1.959964 * se_T_cl_max
	scalar cover_T_cl_max = ((ci_upper_T_cl_max>=truefs) & (ci_lower_T_cl_max<=truefs))	
	
				}

			
				
return scalar bw_CCT = h_bw_CCT
return scalar b_bw_CCT = b_bw_CCT
return scalar ci_upper_rb_CCT = ci_upper_rb_CCT
return scalar ci_lower_rb_CCT = ci_lower_rb_CCT
return scalar cover_rb_CCT = cover_rb_CCT
return scalar tau_F_bc_CCT = tau_F_bc_CCT
return scalar ci_upper_T_rb_CCT = ci_upper_T_rb_CCT
return scalar ci_lower_T_rb_CCT = ci_lower_T_rb_CCT
return scalar cover_T_rb_CCT = cover_T_rb_CCT
return scalar tau_T_bc_CCT = tau_T_bc_CCT
return scalar t_T_rb_CCT = t_T_rb_CCT
return scalar pv_T_rb_CCT = pv_T_rb_CCT

return scalar bw_CCTnoreg = h_bw_CCTnoreg
return scalar b_bw_CCTnoreg = b_bw_CCTnoreg
return scalar ci_upper_rb_CCTnoreg = ci_upper_rb_CCTnoreg
return scalar ci_lower_rb_CCTnoreg = ci_lower_rb_CCTnoreg
return scalar cover_rb_CCTnoreg = cover_rb_CCTnoreg
return scalar tau_F_bc_CCTnoreg = tau_F_bc_CCTnoreg
return scalar ci_upper_T_rb_CCTnoreg = ci_upper_T_rb_CCTnoreg
return scalar ci_lower_T_rb_CCTnoreg = ci_lower_T_rb_CCTnoreg
return scalar cover_T_rb_CCTnoreg = cover_T_rb_CCTnoreg
return scalar tau_T_bc_CCTnoreg = tau_T_bc_CCTnoreg
return scalar t_T_rb_CCTnoreg = t_T_rb_CCTnoreg
return scalar pv_T_rb_CCTnoreg = pv_T_rb_CCTnoreg

return scalar bw_fuzzyCCT = h_bw_fuzzyCCT
return scalar b_bw_fuzzyCCT = b_bw_fuzzyCCT
return scalar ci_upper_rb_fuzzyCCT = ci_upper_rb_fuzzyCCT
return scalar ci_lower_rb_fuzzyCCT = ci_lower_rb_fuzzyCCT
return scalar cover_rb_fuzzyCCT = cover_rb_fuzzyCCT
return scalar tau_F_bc_fuzzyCCT = tau_F_bc_fuzzyCCT
return scalar ci_upper_T_rb_fuzzyCCT = ci_upper_T_rb_fuzzyCCT
return scalar ci_lower_T_rb_fuzzyCCT = ci_lower_T_rb_fuzzyCCT
return scalar cover_T_rb_fuzzyCCT = cover_T_rb_fuzzyCCT
return scalar tau_T_bc_fuzzyCCT = tau_T_bc_fuzzyCCT
return scalar t_T_rb_fuzzyCCT = t_T_rb_fuzzyCCT
return scalar pv_T_rb_fuzzyCCT = pv_T_rb_fuzzyCCT

return scalar bw_l_fuzzyTWO = h_l_fuzzyTWO
return scalar bw_r_fuzzyTWO = h_r_fuzzyTWO
return scalar b_bw_l_fuzzyTWO = b_l_fuzzyTWO
return scalar b_bw_r_fuzzyTWO = b_r_fuzzyTWO
return scalar ci_upper_rb_fuzzyTWO = ci_upper_rb_fuzzyTWO
return scalar ci_lower_rb_fuzzyTWO = ci_lower_rb_fuzzyTWO
return scalar cover_rb_fuzzyTWO = cover_rb_fuzzyTWO
return scalar tau_F_bc_fuzzyTWO = tau_F_bc_fuzzyTWO
return scalar ci_upper_T_rb_fuzzyTWO = ci_upper_T_rb_fuzzyTWO
return scalar ci_lower_T_rb_fuzzyTWO = ci_lower_T_rb_fuzzyTWO
return scalar cover_T_rb_fuzzyTWO = cover_T_rb_fuzzyTWO
return scalar tau_T_bc_fuzzyTWO = tau_T_bc_fuzzyTWO
return scalar t_T_rb_fuzzyTWO = t_T_rb_fuzzyTWO
return scalar pv_T_rb_fuzzyTWO = pv_T_rb_fuzzyTWO

return scalar bw_fuzzyCERCCT = h_bw_fuzzyCERCCT
return scalar b_bw_fuzzyCERCCT = b_bw_fuzzyCERCCT
return scalar ci_upper_rb_fuzzyCERCCT = ci_upper_rb_fuzzyCERCCT
return scalar ci_lower_rb_fuzzyCERCCT = ci_lower_rb_fuzzyCERCCT
return scalar cover_rb_fuzzyCERCCT = cover_rb_fuzzyCERCCT
return scalar tau_F_bc_fuzzyCERCCT = tau_F_bc_fuzzyCERCCT
return scalar ci_upper_T_rb_fuzzyCERCCT = ci_upper_T_rb_fuzzyCERCCT
return scalar ci_lower_T_rb_fuzzyCERCCT = ci_lower_T_rb_fuzzyCERCCT
return scalar cover_T_rb_fuzzyCERCCT = cover_T_rb_fuzzyCERCCT
return scalar tau_T_bc_fuzzyCERCCT = tau_T_bc_fuzzyCERCCT
return scalar t_T_rb_fuzzyCERCCT = t_T_rb_fuzzyCERCCT
return scalar pv_T_rb_fuzzyCERCCT = pv_T_rb_fuzzyCERCCT

return scalar bw_l_fuzzyCERTWO = h_l_fuzzyCERTWO
return scalar bw_r_fuzzyCERTWO = h_r_fuzzyCERTWO
return scalar b_bw_l_fuzzyCERTWO = b_l_fuzzyCERTWO
return scalar b_bw_r_fuzzyCERTWO = b_r_fuzzyCERTWO
return scalar ci_upper_rb_fuzzyCERTWO = ci_upper_rb_fuzzyCERTWO
return scalar ci_lower_rb_fuzzyCERTWO = ci_lower_rb_fuzzyCERTWO
return scalar cover_rb_fuzzyCERTWO = cover_rb_fuzzyCERTWO
return scalar tau_F_bc_fuzzyCERTWO = tau_F_bc_fuzzyCERTWO
return scalar ci_upper_T_rb_fuzzyCERTWO = ci_upper_T_rb_fuzzyCERTWO
return scalar ci_lower_T_rb_fuzzyCERTWO = ci_lower_T_rb_fuzzyCERTWO
return scalar cover_T_rb_fuzzyCERTWO = cover_T_rb_fuzzyCERTWO
return scalar tau_T_bc_fuzzyCERTWO = tau_T_bc_fuzzyCERTWO
return scalar t_T_rb_fuzzyCERTWO = t_T_rb_fuzzyCERTWO
return scalar pv_T_rb_fuzzyCERTWO = pv_T_rb_fuzzyCERTWO

return scalar bw_FG = h_bw_FG
return scalar b_bw_FG = b_bw_FG
return scalar ci_upper_rb_FG = ci_upper_rb_FG
return scalar ci_lower_rb_FG = ci_lower_rb_FG
return scalar cover_rb_FG = cover_rb_FG
return scalar tau_F_bc_FG = tau_F_bc_FG
return scalar ci_upper_T_rb_FG = ci_upper_T_rb_FG
return scalar ci_lower_T_rb_FG = ci_lower_T_rb_FG
return scalar cover_T_rb_FG = cover_T_rb_FG
return scalar tau_T_bc_FG = tau_T_bc_FG
return scalar t_T_rb_FG = t_T_rb_FG
return scalar pv_T_rb_FG = pv_T_rb_FG

return scalar bw_max = h_bw_max
return scalar b_bw_max = b_bw_max
return scalar ci_upper_rb_max = ci_upper_rb_max
return scalar ci_lower_rb_max = ci_lower_rb_max
return scalar cover_rb_max = cover_rb_max
return scalar tau_F_bc_max = tau_F_bc_max
return scalar ci_upper_T_rb_max = ci_upper_T_rb_max
return scalar ci_lower_T_rb_max = ci_lower_T_rb_max
return scalar cover_T_rb_max = cover_T_rb_max
return scalar tau_T_bc_max = tau_T_bc_max
return scalar t_T_rb_max = t_T_rb_max
return scalar pv_T_rb_max = pv_T_rb_max

return scalar ci_upper_cl_CCT = ci_upper_cl_CCT
return scalar ci_lower_cl_CCT = ci_lower_cl_CCT
return scalar cover_cl_CCT = cover_cl_CCT
return scalar tau_F_cl_CCT = tau_F_cl_CCT
return scalar ci_upper_T_cl_CCT = ci_upper_T_cl_CCT
return scalar ci_lower_T_cl_CCT = ci_lower_T_cl_CCT
return scalar cover_T_cl_CCT = cover_T_cl_CCT
return scalar tau_T_cl_CCT = tau_T_cl_CCT
return scalar Fstat_T_cl_CCT = Fstat_T_cl_CCT

return scalar ci_upper_cl_CCTnoreg = ci_upper_cl_CCTnoreg
return scalar ci_lower_cl_CCTnoreg = ci_lower_cl_CCTnoreg
return scalar cover_cl_CCTnoreg = cover_cl_CCTnoreg
return scalar tau_F_cl_CCTnoreg = tau_F_cl_CCTnoreg
return scalar ci_upper_T_cl_CCTnoreg = ci_upper_T_cl_CCTnoreg
return scalar ci_lower_T_cl_CCTnoreg = ci_lower_T_cl_CCTnoreg
return scalar cover_T_cl_CCTnoreg = cover_T_cl_CCTnoreg
return scalar tau_T_cl_CCTnoreg = tau_T_cl_CCTnoreg
return scalar Fstat_T_cl_CCTnoreg = Fstat_T_cl_CCTnoreg

return scalar ci_upper_cl_fuzzyCCT = ci_upper_cl_fuzzyCCT
return scalar ci_lower_cl_fuzzyCCT = ci_lower_cl_fuzzyCCT
return scalar cover_cl_fuzzyCCT = cover_cl_fuzzyCCT
return scalar tau_F_cl_fuzzyCCT = tau_F_cl_fuzzyCCT
return scalar ci_upper_T_cl_fuzzyCCT = ci_upper_T_cl_fuzzyCCT
return scalar ci_lower_T_cl_fuzzyCCT = ci_lower_T_cl_fuzzyCCT
return scalar cover_T_cl_fuzzyCCT = cover_T_cl_fuzzyCCT
return scalar tau_T_cl_fuzzyCCT = tau_T_cl_fuzzyCCT
return scalar Fstat_T_cl_fuzzyCCT = Fstat_T_cl_fuzzyCCT

return scalar ci_upper_cl_fuzzyTWO = ci_upper_cl_fuzzyTWO
return scalar ci_lower_cl_fuzzyTWO = ci_lower_cl_fuzzyTWO
return scalar cover_cl_fuzzyTWO = cover_cl_fuzzyTWO
return scalar tau_F_cl_fuzzyTWO = tau_F_cl_fuzzyTWO
return scalar ci_upper_T_cl_fuzzyTWO = ci_upper_T_cl_fuzzyTWO
return scalar ci_lower_T_cl_fuzzyTWO = ci_lower_T_cl_fuzzyTWO
return scalar cover_T_cl_fuzzyTWO = cover_T_cl_fuzzyTWO
return scalar tau_T_cl_fuzzyTWO = tau_T_cl_fuzzyTWO
return scalar Fstat_T_cl_fuzzyTWO = Fstat_T_cl_fuzzyTWO

return scalar ci_upper_cl_fuzzyCERCCT = ci_upper_cl_fuzzyCERCCT
return scalar ci_lower_cl_fuzzyCERCCT = ci_lower_cl_fuzzyCERCCT
return scalar cover_cl_fuzzyCERCCT = cover_cl_fuzzyCERCCT
return scalar tau_F_cl_fuzzyCERCCT = tau_F_cl_fuzzyCERCCT
return scalar ci_upper_T_cl_fuzzyCERCCT = ci_upper_T_cl_fuzzyCERCCT
return scalar ci_lower_T_cl_fuzzyCERCCT = ci_lower_T_cl_fuzzyCERCCT
return scalar cover_T_cl_fuzzyCERCCT = cover_T_cl_fuzzyCERCCT
return scalar tau_T_cl_fuzzyCERCCT = tau_T_cl_fuzzyCERCCT
return scalar Fstat_T_cl_fuzzyCERCCT = Fstat_T_cl_fuzzyCERCCT

return scalar ci_upper_cl_fuzzyCERTWO = ci_upper_cl_fuzzyCERTWO
return scalar ci_lower_cl_fuzzyCERTWO = ci_lower_cl_fuzzyCERTWO
return scalar cover_cl_fuzzyCERTWO = cover_cl_fuzzyCERTWO
return scalar tau_F_cl_fuzzyCERTWO = tau_F_cl_fuzzyCERTWO
return scalar ci_upper_T_cl_fuzzyCERTWO = ci_upper_T_cl_fuzzyCERTWO
return scalar ci_lower_T_cl_fuzzyCERTWO = ci_lower_T_cl_fuzzyCERTWO
return scalar cover_T_cl_fuzzyCERTWO = cover_T_cl_fuzzyCERTWO
return scalar tau_T_cl_fuzzyCERTWO = tau_T_cl_fuzzyCERTWO
return scalar Fstat_T_cl_fuzzyCERTWO = Fstat_T_cl_fuzzyCERTWO

return scalar ci_upper_cl_FG = ci_upper_cl_FG
return scalar ci_lower_cl_FG = ci_lower_cl_FG
return scalar cover_cl_FG = cover_cl_FG
return scalar tau_F_cl_FG = tau_F_cl_FG
return scalar ci_upper_T_cl_FG = ci_upper_T_cl_FG
return scalar ci_lower_T_cl_FG = ci_lower_T_cl_FG
return scalar cover_T_cl_FG = cover_T_cl_FG
return scalar tau_T_cl_FG = tau_T_cl_FG
return scalar Fstat_T_cl_FG = Fstat_T_cl_FG

return scalar ci_upper_cl_max = ci_upper_cl_max
return scalar ci_lower_cl_max = ci_lower_cl_max
return scalar cover_cl_max = cover_cl_max
return scalar tau_F_cl_max = tau_F_cl_max
return scalar ci_upper_T_cl_max = ci_upper_T_cl_max
return scalar ci_lower_T_cl_max = ci_lower_T_cl_max
return scalar cover_T_cl_max = cover_T_cl_max
return scalar tau_T_cl_max = tau_T_cl_max
return scalar Fstat_T_cl_max = Fstat_T_cl_max


end


** local linear original sample size **

#delimit ;
parallel sim, expr(bw_CCT=r(bw_CCT) bw_CCTnoreg=r(bw_CCTnoreg) bw_fuzzyCCT=r(bw_fuzzyCCT) bw_l_fuzzyTWO=r(bw_l_fuzzyTWO) bw_r_fuzzyTWO=r(bw_r_fuzzyTWO) 
bw_fuzzyCERCCT=r(bw_fuzzyCERCCT) bw_l_fuzzyCERTWO=r(bw_l_fuzzyCERTWO) bw_r_fuzzyCERTWO=r(bw_r_fuzzyCERTWO) bw_FG=r(bw_FG) bw_max=r(bw_max)
b_bw_CCT=r(b_bw_CCT) b_bw_CCTnoreg=r(b_bw_CCTnoreg) b_bw_fuzzyCCT=r(b_bw_fuzzyCCT) b_bw_l_fuzzyTWO=r(b_bw_l_fuzzyTWO) b_bw_r_fuzzyTWO=r(b_bw_r_fuzzyTWO) 
b_bw_fuzzyCERCCT=r(b_bw_fuzzyCERCCT) b_bw_l_fuzzyCERTWO=r(b_bw_l_fuzzyCERTWO) b_bw_r_fuzzyCERTWO=r(b_bw_r_fuzzyCERTWO) b_bw_FG=r(b_bw_FG) b_bw_max=r(b_bw_max)
ci_upper_rb_CCT=r(ci_upper_rb_CCT) ci_upper_rb_CCTnoreg=r(ci_upper_rb_CCTnoreg) ci_upper_rb_fuzzyCCT=r(ci_upper_rb_fuzzyCCT) 
ci_upper_rb_fuzzyTWO=r(ci_upper_rb_fuzzyTWO) ci_upper_rb_FG=r(ci_upper_rb_FG) ci_upper_rb_max=r(ci_upper_rb_max)
ci_lower_rb_CCT=r(ci_lower_rb_CCT) ci_lower_rb_CCTnoreg=r(ci_lower_rb_CCTnoreg) ci_lower_rb_fuzzyCCT=r(ci_lower_rb_fuzzyCCT) 
ci_lower_rb_fuzzyTWO=r(ci_lower_rb_fuzzyTWO) ci_lower_rb_fuzzyCERCCT=r(ci_lower_rb_fuzzyCERCCT) 
ci_lower_rb_fuzzyCERTWO=r(ci_lower_rb_fuzzyCERTWO) ci_lower_rb_FG=r(ci_lower_rb_FG) ci_lower_rb_max=r(ci_lower_rb_max)
cover_rb_CCT=r(cover_rb_CCT) cover_rb_CCTnoreg=r(cover_rb_CCTnoreg) cover_rb_fuzzyCCT=r(cover_rb_fuzzyCCT) 
cover_rb_fuzzyTWO=r(cover_rb_fuzzyTWO) cover_rb_fuzzyCERCCT=r(cover_rb_fuzzyCERCCT) 
cover_rb_fuzzyCERTWO=r(cover_rb_fuzzyCERTWO) cover_rb_FG=r(cover_rb_FG) cover_rb_max=r(cover_rb_max) 
tau_F_bc_CCT=r(tau_F_bc_CCT) tau_F_bc_CCTnoreg=r(tau_F_bc_CCTnoreg) tau_F_bc_fuzzyCCT=r(tau_F_bc_fuzzyCCT) 
tau_F_bc_fuzzyTWO=r(tau_F_bc_fuzzyTWO) tau_F_bc_fuzzyCERCCT=r(tau_F_bc_fuzzyCERCCT) 
tau_F_bc_fuzzyCERTWO=r(tau_F_bc_fuzzyCERTWO) tau_F_bc_FG=r(tau_F_bc_FG) tau_F_bc_max=r(tau_F_bc_max) 
ci_upper_T_rb_CCT=r(ci_upper_T_rb_CCT) ci_upper_T_rb_CCTnoreg=r(ci_upper_T_rb_CCTnoreg) ci_upper_T_rb_fuzzyCCT=r(ci_upper_T_rb_fuzzyCCT) 
ci_upper_T_rb_fuzzyTWO=r(ci_upper_T_rb_fuzzyTWO) ci_upper_T_rb_fuzzyCERCCT=r(ci_upper_T_rb_fuzzyCERCCT) 
ci_upper_T_rb_fuzzyCERTWO=r(ci_upper_T_rb_fuzzyCERTWO) ci_upper_T_rb_FG=r(ci_upper_T_rb_FG) ci_upper_T_rb_max=r(ci_upper_T_rb_max) 
ci_lower_T_rb_CCT=r(ci_lower_T_rb_CCT) ci_lower_T_rb_CCTnoreg=r(ci_lower_T_rb_CCTnoreg) ci_lower_T_rb_fuzzyCCT=r(ci_lower_T_rb_fuzzyCCT) 
ci_lower_T_rb_fuzzyTWO=r(ci_lower_T_rb_fuzzyTWO) ci_lower_T_rb_fuzzyCERCCT=r(ci_lower_T_rb_fuzzyCERCCT) 
ci_lower_T_rb_fuzzyCERTWO=r(ci_lower_T_rb_fuzzyCERTWO) ci_lower_T_rb_FG=r(ci_lower_T_rb_FG) ci_lower_T_rb_max=r(ci_lower_T_rb_max) 
cover_T_rb_CCT=r(cover_T_rb_CCT) cover_T_rb_CCTnoreg=r(cover_T_rb_CCTnoreg) cover_T_rb_fuzzyCCT=r(cover_T_rb_fuzzyCCT) 
cover_T_rb_fuzzyTWO=r(cover_T_rb_fuzzyTWO) cover_T_rb_fuzzyCERCCT=r(cover_T_rb_fuzzyCERCCT) 
cover_T_rb_fuzzyCERTWO=r(cover_T_rb_fuzzyCERTWO) cover_T_rb_FG=r(cover_T_rb_FG) cover_T_rb_max=r(cover_T_rb_max) 
tau_T_bc_CCT=r(tau_T_bc_CCT) tau_T_bc_CCTnoreg=r(tau_T_bc_CCTnoreg) tau_T_bc_fuzzyCCT=r(tau_T_bc_fuzzyCCT) 
tau_T_bc_fuzzyTWO=r(tau_T_bc_fuzzyTWO) tau_T_bc_fuzzyCERCCT=r(tau_T_bc_fuzzyCERCCT) 
tau_T_bc_fuzzyCERTWO=r(tau_T_bc_fuzzyCERTWO) tau_T_bc_FG=r(tau_T_bc_FG) tau_T_bc_max=r(tau_T_bc_max) 
t_T_rb_CCT=r(t_T_rb_CCT) t_T_rb_CCTnoreg=r(t_T_rb_CCTnoreg) t_T_rb_fuzzyCCT=r(t_T_rb_fuzzyCCT) 
t_T_rb_fuzzyTWO=r(t_T_rb_fuzzyTWO) t_T_rb_fuzzyCERCCT=r(t_T_rb_fuzzyCERCCT) 
t_T_rb_fuzzyCERTWO=r(t_T_rb_fuzzyCERTWO) t_T_rb_FG=r(t_T_rb_FG) t_T_rb_max=r(t_T_rb_max)
pv_T_rb_CCT=r(pv_T_rb_CCT) pv_T_rb_CCTnoreg=r(pv_T_rb_CCTnoreg) pv_T_rb_fuzzyCCT=r(pv_T_rb_fuzzyCCT) 
pv_T_rb_fuzzyTWO=r(pv_T_rb_fuzzyTWO) pv_T_rb_fuzzyCERCCT=r(pv_T_rb_fuzzyCERCCT) 
pv_T_rb_fuzzyCERTWO=r(pv_T_rb_fuzzyCERTWO) pv_T_rb_FG=r(pv_T_rb_FG) pv_T_rb_max=r(pv_T_rb_max) 
ci_upper_cl_CCT=r(ci_upper_cl_CCT) ci_upper_cl_CCTnoreg=r(ci_upper_cl_CCTnoreg) ci_upper_cl_fuzzyCCT=r(ci_upper_cl_fuzzyCCT) 
ci_upper_cl_fuzzyTWO=r(ci_upper_cl_fuzzyTWO) ci_upper_cl_fuzzyCERCCT=r(ci_upper_cl_fuzzyCERCCT) 
ci_upper_cl_fuzzyCERTWO=r(ci_upper_cl_fuzzyCERTWO) ci_upper_cl_FG=r(ci_upper_cl_FG) ci_upper_cl_max=r(ci_upper_cl_max)
ci_lower_cl_CCT=r(ci_lower_cl_CCT) ci_lower_cl_CCTnoreg=r(ci_lower_cl_CCTnoreg) ci_lower_cl_fuzzyCCT=r(ci_lower_cl_fuzzyCCT) 
ci_lower_cl_fuzzyTWO=r(ci_lower_cl_fuzzyTWO) ci_lower_cl_fuzzyCERCCT=r(ci_lower_cl_fuzzyCERCCT) 
ci_lower_cl_fuzzyCERTWO=r(ci_lower_cl_fuzzyCERTWO) ci_lower_cl_FG=r(ci_lower_cl_FG) ci_lower_cl_max=r(ci_lower_cl_max) 
cover_cl_CCT=r(cover_cl_CCT) cover_cl_CCTnoreg=r(cover_cl_CCTnoreg) cover_cl_fuzzyCCT=r(cover_cl_fuzzyCCT) 
cover_cl_fuzzyTWO=r(cover_cl_fuzzyTWO) cover_cl_fuzzyCERCCT=r(cover_cl_fuzzyCERCCT) 
cover_cl_fuzzyCERTWO=r(cover_cl_fuzzyCERTWO) cover_cl_FG=r(cover_cl_FG) cover_cl_max=r(cover_cl_max)
tau_F_cl_CCT=r(tau_F_cl_CCT) tau_F_cl_CCTnoreg=r(tau_F_cl_CCTnoreg) tau_F_cl_fuzzyCCT=r(tau_F_cl_fuzzyCCT) 
tau_F_cl_fuzzyTWO=r(tau_F_cl_fuzzyTWO) tau_F_cl_fuzzyCERCCT=r(tau_F_cl_fuzzyCERCCT) 
tau_F_cl_fuzzyCERTWO=r(tau_F_cl_fuzzyCERTWO) tau_F_cl_FG=r(tau_F_cl_FG) tau_F_cl_max=r(tau_F_cl_max) 
ci_upper_T_cl_CCT=r(ci_upper_T_cl_CCT) ci_upper_T_cl_CCTnoreg=r(ci_upper_T_cl_CCTnoreg) ci_upper_T_cl_fuzzyCCT=r(ci_upper_T_cl_fuzzyCCT) 
ci_upper_T_cl_fuzzyTWO=r(ci_upper_T_cl_fuzzyTWO) ci_upper_T_cl_fuzzyCERCCT=r(ci_upper_T_cl_fuzzyCERCCT) 
ci_upper_T_cl_fuzzyCERTWO=r(ci_upper_T_cl_fuzzyCERTWO) ci_upper_T_cl_FG=r(ci_upper_T_cl_FG) ci_upper_T_cl_max=r(ci_upper_T_cl_max)
ci_lower_T_cl_CCT=r(ci_lower_T_cl_CCT) ci_lower_T_cl_CCTnoreg=r(ci_lower_T_cl_CCTnoreg) ci_lower_T_cl_fuzzyCCT=r(ci_lower_T_cl_fuzzyCCT) 
ci_lower_T_cl_fuzzyTWO=r(ci_lower_T_cl_fuzzyTWO) ci_lower_T_cl_fuzzyCERCCT=r(ci_lower_T_cl_fuzzyCERCCT) 
ci_lower_T_cl_fuzzyCERTWO=r(ci_lower_T_cl_fuzzyCERTWO) ci_lower_T_cl_FG=r(ci_lower_T_cl_FG) ci_lower_T_cl_max=r(ci_lower_T_cl_max)
cover_T_cl_CCT=r(cover_T_cl_CCT) cover_T_cl_CCTnoreg=r(cover_T_cl_CCTnoreg) cover_T_cl_fuzzyCCT=r(cover_T_cl_fuzzyCCT) 
cover_T_cl_fuzzyTWO=r(cover_T_cl_fuzzyTWO) cover_T_cl_fuzzyCERCCT=r(cover_T_cl_fuzzyCERCCT) 
cover_T_cl_fuzzyCERTWO=r(cover_T_cl_fuzzyCERTWO) cover_T_cl_FG=r(cover_T_cl_FG) cover_T_cl_max=r(cover_T_cl_max)
tau_T_cl_CCT=r(tau_T_cl_CCT) tau_T_cl_CCTnoreg=r(tau_T_cl_CCTnoreg) tau_T_cl_fuzzyCCT=r(tau_T_cl_fuzzyCCT) 
tau_T_cl_fuzzyTWO=r(tau_T_cl_fuzzyTWO) tau_T_cl_fuzzyCERCCT=r(tau_T_cl_fuzzyCERCCT) 
tau_T_cl_fuzzyCERTWO=r(tau_T_cl_fuzzyCERTWO) tau_T_cl_FG=r(tau_T_cl_FG) tau_T_cl_max=r(tau_T_cl_max)
Fstat_T_cl_CCT=r(Fstat_T_cl_CCT) Fstat_T_cl_CCTnoreg=r(Fstat_T_cl_CCTnoreg) Fstat_T_cl_fuzzyCCT=r(Fstat_T_cl_fuzzyCCT) 
Fstat_T_cl_fuzzyTWO=r(Fstat_T_cl_fuzzyTWO) Fstat_T_cl_fuzzyCERCCT=r(Fstat_T_cl_fuzzyCERCCT) 
Fstat_T_cl_fuzzyCERTWO=r(Fstat_T_cl_fuzzyCERTWO) Fstat_T_cl_FG=r(Fstat_T_cl_FG) Fstat_T_cl_max=r(Fstat_T_cl_max)) seeds(1 2 3 4) reps(1000) : sim_clpw_kink3_quintic_newdata, poly(1);

#delimit cr



save "data\sim_emp_kink3_quintic_summary_ll.dta", replace

log close
